/****************************/
/* 複雑な待ち行列問題       */
/*      coded by Y.Suganuma */
/****************************/
base = null;
cus = new Array();   // 系内にいる客のリスト
inl = new Array();   // Inletオブジェクトリスト
que = new Array();   // Queueオブジェクトリスト
ent = new Array();   // Entityオブジェクトリスト
check = true;

/****************/
/* main program */
/****************/
function main()
{
	check = true;
	cus.splice(0);   // 系内にいる客のリスト
	inl.splice(0);   // Inletオブジェクトリスト
	que.splice(0);   // Queueオブジェクトリスト
	ent.splice(0);   // Entityオブジェクトリスト
/*
          入力データ
*/
					// 入り口
	let n_i = parseInt(document.getElementById("n_i").value);   // 入り口(Inlet)の数
	for (let i1 = 1; i1 <= n_i; i1++) {
		let name1 = document.getElementById("i"+i1).value;   // 入り口の名前
		let n     = parseInt(document.getElementById("a_t"+i1).value);   // 到着分布
		let m_a   = 0;
		let y     = new Array();
		if (n == 0 || n == 1)
			m_a = parseFloat(document.getElementById("ma"+i1).value);   // 平均到着時間間隔，到着時間間隔
		else {
			if (n > 0) {
				alert("***error input1 人数が不適当です " + n);
				check = false;
			}
			else {
				let m = -n;
				let x = document.getElementById("at"+i1).value.split(" ");
				if (m != x.length) {
					alert("***error input2 人数とデータ数が異なっています " + m + " "  + x.length);
					check = false;
				}
				else {
					for (let i2 = 0; i2 < m; i2++)
						y.push(parseFloat(x[i2]));
				}
			}
		}
		let name2 = document.getElementById("iq"+i1).value;   // 並ぶ待ち行列の名前
		let inl_e = new Inlet(name1, n, m_a, y, name2);
		inl.push(inl_e);
	}
					// 待ち行列
	let n_q = parseInt(document.getElementById("n_q").value);   // 待ち行列(Queue)の数
	for (let i1 = 1; i1 <= n_q; i1++) {
		let name1 = document.getElementById("q"+i1).value;   // 待ち行列の名前
		let n = parseInt(document.getElementById("qi"+i1).value);   // 入り口(0)，または，窓口(n>0，窓口の数)
		let inn = new Array();
		if (n == 0) {
			let name2 = document.getElementById("qii"+i1+"1").value;   // 待ち行列の名前;
			inn.push(name2);
		}
		else {
			for (let i2 = 1; i2 <= n; i2++) {
				let name3 = document.getElementById("qie"+i1+i2).value;   // 窓口の名前
				inn.push(name3);
			}
		}
		let m = parseInt(document.getElementById("qo"+i1).value);   // 処理する窓口の数
		let out = new Array();
		for (let i2 = 1; i2 <= m; i2++) {
			let name4 = document.getElementById("qoe"+i1+i2).value;   // 窓口の名前
			out.push(name4);
		}
		let que_e = new Queue(name1, n, inn, m, out);
		que.push(que_e);
	}
					// 窓口
	let n_e = parseInt(document.getElementById("n_e").value);   // 窓口(Entity)の数;
	for (let i1 = 1; i1 <= n_e; i1++) {
		let name1 = document.getElementById("e"+i1).value;   // 窓口の名前
		let s_t = parseInt(document.getElementById("s_t"+i1).value);   // サービス分布
		let m_s = parseFloat(document.getElementById("ms"+i1).value);   // 平均サービス時間，サービス時間
		let name2 = document.getElementById("eq"+i1).value;   // 待ち行列(入力)の名前
		let sw = parseInt(document.getElementById("eo"+i1).value);   // 外部(0)，または，待ち行列(1)
		let name3;
		if (sw > 0)
			name3 = document.getElementById("eoq"+i1).value;   // 待ち行列(出力)の名前
		let ent_e = new Entity(name1, s_t, m_s, name2, sw, name3);
		ent.push(ent_e);
	}
					// シミュレーション終了時間
	let end = parseFloat(document.getElementById("end").value);   // シミュレーション終了時間

	if (check) {
		base = new Q_base(end)   // 全体の制御を行うクラス
		if (check) {
				// 実行
			base.Control();
					// 出力
			base.Output();
		}
	}
}

/**********************/
/* 指数分布乱数の発生 */
/*      m : 平均値    */
/*      rerutn : 乱数 */
/**********************/
function Exp_b(m)
{
	return -m * Math.log(Math.random());
}

/************************************************************/
/* Inletオブジェクトの定義                                  */
/*      name1 : 入り口名                                    */
/*      a_t;   // = -n : 到着する客の人数を負の値にしたもの */
/*             // =0 : 指数分布                             */
/*             // =1 : 一定時間間隔                         */
/*      m_a： 到着時間間隔またはその平均                    */
/*      que : 客の到着時刻リスト                            */
/*      name2 : 待ち行列名                                  */
/************************************************************/
function Inlet(name1, n, m_a, que, name2)
{
	this.name = name1;   // 入り口名
	this.out = name2;   // 待ち行列名
	this.out_n;   // 待ち行列番号
	this.a_t = n;   // = -n : 到着する客の人数を負の値にしたもの
	                // =0 : 指数分布
	                // =1 : 一定時間間隔
	this.mean = m_a;   // 到着時間間隔またはその平均
	this.que = que;   // 客の到着時刻リスト
	if (this.a_t == 0)   // 次の客の到着時刻（負：客がない）
		this.arrive_time = Exp_b(this.mean);
	else if (this.a_t == 1)
		this.arrive_time = 0;
	else
		this.arrive_time = que.shift();

	return this;
}

/*********************************************/
/* Queueオブジェクトの定義                   */
/*      name1 : 待ち行列名                   */
/*      n1 : =0 : 入り口から入る             */
/*           >0 : 複数の窓口から入る(窓口数) */
/*      in1 : 入り口名，または，窓口名       */
/*      m1 : 処理する窓口数                  */
/*      out1 : 窓口名                        */
/*********************************************/
function Queue(name1, n1, in1, m1, out1)
{
	this.name = name1;   // 待ち行列名
	this.nc = 0;   // 待ち行列への到着客数カウンタ
	this.max_q_l = 0;   // 最大待ち行列長
	this.c_ql = 0.0;   // 待ち行列長にその長さが継続した時間を乗じた値の累計
	this.ql_t = 0.0;   // 現在の待ち行列長になった時間
	this.max_wt = 0.0;   // 最大待ち時間
	this.c_wt = 0.0;   // 待ち時間の累計
	this.n = n1;   // =0 : 入り口から入る
		           // >0 : 複数の窓口から入る(窓口数)
	this.inn = in1;   // 入り口名，または，窓口名
	this.in_n = new Array();   // 入り口番号，または，窓口番号
	this.m = m1;   // 処理する窓口数
	this.out = out1;   // 窓口名
	this.out_n = new Array();   // 窓口番号
	this.que = new Array();   // 待ち行列

	return this;
}

/*************************************/
/* Entityオブジェクトの定義          */
/*      name1 : 窓口名               */
/*		int s_t;   // =0 : 指数分布  */
/*		           // =1 : 一定時間  */
/*      m_s：平均サービス時間        */
/*      in : 待ち行列(入力)の名前    */
/*      sw : =0 : システムの外に出る */
/*           =1 : 待ち行列に入る     */
/*      out : 待ち行列(出力)の名前   */
/*************************************/
function Entity(name1, s_t, m_s, name2, sw, name3)
{
	this.name = name1;   // 窓口名
	this.end_time = -1.0;   // サービス終了時刻（負：何も処理していない）
	this.s_t = s_t;   // =0 : 指数分布
		              // =1 : 一定時間
	this.mean = m_s;   // 平均サービス時間
	this.busy_t = -1.0;   // 窓口がふさがった時刻
	this.c_busy = 0.0;   // 窓口がふさがっている時間の累計
	this.service = 0;   // サービス中の客番号（0のときは無し）
	this.inn = name2;   // 待ち行列(入力)の名前
	this.in_n = 0;   // 待ち行列(入力)番号
	this.to = sw;   // =0 : システムの外に出る
		            // =1 : 待ち行列に入る
	this.out = name3;   // 待ち行列(出力)の名前
	this.out_n = 0;   // 待ち行列(出力)番号

	return this;
}

/******************************/
/* Customerオブジェクトの定義 */
/*      n : 客番号            *
/*      s1,s2 : 状態          */
/*      t : 到着時刻          */
/******************************/
function Customer(n, s1, s2, t)
{
	this.num = n;   // 客番号
	this.state1 = s1;   // 客の状態1
	                    //   =0 : 待ち行列に入ってい
	                    //   =1 : サービスを受けている
	this.state2 = s2;   // 客の状態2(待ち行列番号，または，窓口番号）
	this.time = t;   // 到着時刻

	return this;
}

/*************************************/
/* Q_baseオブジェクトの定義          */
/*      e : シミュレーション終了時刻 */
/*************************************/
function Q_base(e)
{
	this.p_time = 0.0;  // 現在時刻
	this.max_c = 0;   // 最大系内客数
	this.nc = 0;   // システムへの到着客数カウンタ
	this.now_c_t = 0.0;   // 現在の系内客数になった時間
	this.c_now_c = 0.0;   // 系内客数にその数が継続した時間を乗じた値の累計
	this.c_sys = 0.0;   // 滞在時間の累計
	this.max_sys = 0.0;   // 最大滞在時間
	this.end = e;   // シミュレーション終了時間
					// 接続関係のチェック
							// Inlet
	for (let i1 = 0; i1 < inl.length-1; i1++) {
		for (let i2 = i1+1; i2 < inl.length; i2++) {
			if (inl[i1].name == inl[i2].name) {
				alert("***error1 同じ名前の入り口があります " + inl[i1].name);
				check = false;
			}
		}
	}

	let k;
	for (let i1 = 0; i1 < inl.length; i1++) {
		k = -1;
		for (let i2 = 0; i2 < que.length; i2++) {
			if (inl[i1].out == que[i2].name) {
				k = i2;
				break;
			}
		}
		if (k >= 0)
			inl[i1].out_n = k;
		else {
			alert("***error2 入り口から入る待ち行列名が不適当です " + inl[i1].out);
			check = false;
		}
	}
							// Queue
	for (let i1 = 0; i1 < que.length-1; i1++) {
		for (let i2 = i1+1; i2 < que.length; i2++) {
			if (que[i1].name == que[i2].name) {
				alert("***error3 同じ名前の待ち行列があります " + que[i1].name);
				check = false;
			}
		}
	}

	for (let i1 = 0; i1 < que.length; i1++) {
		if (que[i1].n == 0) {
			k = -1;
			for (let i2 = 0; i2 < inl.length; i2++) {
				if (que[i1].inn[0] == inl[i2].name) {
					k = i2;
					break;
				}
			}
			if (k >= 0)
				que[i1].in_n.push(k);
			else {
				alert("***error4 待ち行列に入る入り口名が不適当です " + que[i1].inn[0]);
				check = false;
			}
		}
		else {
			for (let i2 = 0; i2 < que[i1].n; i2++) {
				k = -1;
				for (let i3 = 0; i3 < ent.length; i3++) {
					if (que[i1].inn[i2] == ent[i3].name) {
						k = i3;
						break;
					}
				}
				if (k >= 0)
					que[i1].in_n.push(k);
				else {
					alert("***error5 待ち行列に入る窓口名が不適当です " + que[i1].inn[i2]);
					check = false;
				}
			}
		}
		for (let i2 = 0; i2 < que[i1].m; i2++) {
			k = -1;
			for (let i3 = 0; i3 < ent.length; i3++) {
				if (que[i1].out[i2] == ent[i3].name) {
					k = i3;
					break;
				}
			}
			if (k >= 0)
				que[i1].out_n.push(k);
			else {
				alert("***error6 待ち行列を処理する窓口名が不適当です " + que[i1].out[i2]);
				check = false;
			}
		}
	}
							// Entity
	for (let i1 = 0; i1 < ent.length-1; i1++) {
		k = -1;
		for (let i2 = i1+1; i2 < ent.length; i2++) {
			if (ent[i1].name == ent[i2].name) {
				alert("***error7 同じ名前の窓口があります " + ent[i1].name);
				check = false;
			}
		}
	}

	for (let i1 = 0; i1 < ent.length; i1++) {
		k = -1;
		for (let i2 = 0; i2 < que.length; i2++) {
			if (ent[i1].inn == que[i2].name) {
				k = i2;
				break;
			}
		}
		if (k >= 0)
			ent[i1].in_n = k;
		else {
			alert("***error8 窓口に入る待ち行列名が不適当です " + ent[i1].inn);
			check = false;
		}
		if (ent[i1].to > 0) {
			k = -1;
			for (let i2 = 0; i2 < que.length; i2++) {
				if (ent[i1].out == que[i2].name) {
					k = i2;
					break;
				}
			}
			if (k >= 0)
				ent[i1].out_n = k;
			else {
				alert("***error9 窓口の出口にある待ち行列名が不適当です " + ent[i1].out);
				check = false;
			}
		}
	}

	return this;
}

/**************/
/* 全体の制御 */
/**************/
Q_base.prototype.Control = function()
{
	let sw = new Array(2);
	sw[0]  = 0;
	while (sw[0] > -2) {
		base.Next(sw);   // 次の処理の選択
		if (sw[0] == -1)
			sw[0] = base.End_o_s();   // シミュレーションの終了
		else {
			if (sw[0] == 0)
				base.Arrive(sw[1]);   // 客の到着処理
			else
				base.Service(sw[1]);   // サービスの終了
		}
	}
}

/*********************************************/
/* 次の処理の決定                            */
/*      sw[0] : =-1 : シミュレーションの終了 */
/*              =0  : 客の到着処理           */
/*              =1  : 窓口のサービス終了     */
/*        [1] : 入り口番号 or 窓口番号       */
/*********************************************/
Q_base.prototype.Next = function(sw)
{
	let tm = base.end;   // 次の処理時刻
	sw[0]  = -1;
					// 次の客の到着時刻
	for (let i1 = 0; i1 < inl.length; i1++) {
		let x = inl[i1];
		if (x.arrive_time >= 0.0 && x.arrive_time < tm) {
			sw[0] = 0;
			sw[1] = i1;
			tm    = x.arrive_time;
		}
	}
					// サービス終了時刻
	for (let i1 = 0; i1 < ent.length; i1++) {
		let x = ent[i1];
		if (x.service > 0 && x.end_time <= tm) {
			sw[0] = 1;
			sw[1] = i1;
			tm    = x.end_time;
		}
	}

	if (sw[0] < 0)
		base.end = base.p_time;

	return sw;
}

/**********************************/
/* 終了処理                       */
/*      return : =-1 : 終了前処理 */
/*               =-2 : 実際の終了 */
/**********************************/
Q_base.prototype.End_o_s = function()
{
	let sw = -2;
	base.p_time = base.end;   // 現在時刻

	for (let i1 = 0; i1 < ent.length; i1++) {
		let x = ent[i1];
		if (x.service > 0) {   // サービス中の客はいるか？
			if (sw == -2) {
				sw = -1;
				base.end = x.end_time;   // 窓口i1のサービス終了時刻
			}
			else {
				if (x.end_time > base.end)
					base.end = x.end_time;   // 窓口i1のサービス終了時刻
			}
		}
	}

	return sw;
}

/************************/
/* 客の到着処理         */
/*      kk : 入り口番号 */
/************************/
Q_base.prototype.Arrive = function(kk)
{
/*
          客数の増加と次の客の到着時刻の設定
*/
	base.nc     += 1;   // 到着客数カウンタ
	base.p_time  = inl[kk].arrive_time;   // 現在時刻
	if (inl[kk].a_t == 0)   // 次の客の到着時刻
		inl[kk].arrive_time = base.p_time + Exp_b(inl[kk].mean);   
	else if (inl[kk].a_t == 1)
		inl[kk].arrive_time = base.p_time + inl[kk].mean;   
	else {
		if (inl[kk].que.length <= 0)
			inl[kk].arrive_time = -1.0;
		else
			inl[kk].arrive_time = inl[kk].que.shift();
	}
	if (inl[kk].arrive_time >= base.end)
		inl[kk].arrive_time = -1.0;
/*
          系内客数の処理
*/
	base.c_now_c += cus.length * (base.p_time - base.now_c_t);   // 系内客数にその数が継続した時間を乗じた値の累計
	base.now_c_t  = base.p_time;   // 現在の系内客数になった時刻
	if (cus.length+1 > base.max_c)
		base.max_c = cus.length + 1;   // 最大系内客数
/*
          空いている窓口を探す
*/
	let k1 = inl[kk].out_n;
	que[k1].nc++;
	let k = -1;
	for (let i1 = 0; i1 < que[k1].m; i1++) {
		let k2 = que[k1].out_n[i1];   // 処理窓口
		if (ent[k2].service == 0) {
			k = k2;
			break;
		}
	}
/*
          窓口に空きがない場合
*/
	if (k < 0) {
		let ct_p = new Customer(base.nc, 0, k1, base.p_time);
		cus.push(ct_p);   // 客の登録（系内客数）
		que[k1].c_ql += que[k1].que.length * (base.p_time - que[k1].ql_t);   // 待ち行列長にその長さが継続した時間を乗じた値の累計
		que[k1].que.push(base.nc);   // 客の登録（待ち行列）
		que[k1].ql_t = base.p_time;   // 現在の待ち行列長になった時刻
		if (que[k1].que.length > que[k1].max_q_l)
			que[k1].max_q_l = que[k1].que.length;   // 最大待ち行列長
	}
/*
          すぐサービスをうけられる場合
*/
	else {
		let ct_p = new Customer(base.nc, 1, k, base.p_time);
		cus.push(ct_p);   // 客の登録（系内客数）
		ent[k].service  = base.nc;   // サービスを受けている客番号
		ent[k].busy_t   = base.p_time;   // 窓口がふさがった時刻
		if (ent[k].s_t == 0)   // 窓口のサービス終了時刻
			ent[k].end_time = base.p_time + Exp_b(ent[k].mean);
		else
			ent[k].end_time = base.p_time + ent[k].mean;
	}
}

/**********************************/
/* サービス終了時の処理           */
/*      kk : サービス終了窓口番号 */
/**********************************/
Q_base.prototype.Service = function(kk)
{
/*
          時間の設定
*/
	base.p_time = ent[kk].end_time;   // 現在時刻
	ent[kk].end_time = -1.0;   // サービス終了時間
/*
          システムの外へ出る場合
*/
	if (ent[kk].to == 0) {
/*
               系内客数の処理
*/
		base.c_now_c += cus.length * (base.p_time - base.now_c_t);   // 系内客数にその数が継続した時間を乗じた値の累計
		base.now_c_t  = base.p_time;   // 現在の系内客数になった時刻
/*
               滞在時間の処理
*/
		let n  = base.Search(ent[kk].service);   // サービス中の客
		let x1 = base.p_time - cus[n].time;
		base.c_sys += x1;   // 滞在時間の累計
		if (x1 > base.max_sys)
			base.max_sys = x1;   // 最大滞在時間
		cus.splice(n, 1);   // 客の削除（系内客数）
	}
/*
          他の窓口処理へ入る場合の処理
*/
	else {
		let k1 = ent[kk].out_n;
		que[k1].nc++;
		let sw = 1;
		let k2 = 0;
		if (que[k1].que.length == 0) {
			for (let i1 = 0; i1 < que[k1].m; i1++) {
				k2 = que[k1].out_n[i1];   // 窓口
				if (ent[k2].service == 0) {
					sw = 0;
					break;
				}
			}
		}
/*
               待ち行列がある場合
*/
		if (sw > 0) {
			que[k1].c_ql += que[k1].que.length * (base.p_time - que[k1].ql_t);   // 待ち行列長にその長さが継続した時間を乗じた値の累計
			que[k1].que.push(ent[kk].service);   // 客の登録（待ち行列）
			que[k1].ql_t = base.p_time;   // 現在の待ち行列長になった時刻
			if (que[k1].que.length > que[k1].max_q_l)
				que[k1].max_q_l = que[k1].que.length;   // 最大待ち行列長
			let m = base.Search(ent[kk].service);
			cus[m].state1 = 0;   // 客の状態変更(待ち行列)
			cus[m].state2 = ent[kk].out_n;   // 客の状態変更(待ち行列番号)
		}
/*
               すぐサービスをうけられる場合
*/
		else {
			ent[k2].service  = ent[kk].service;   // サービスを受けている客番号
			ent[k2].busy_t   = base.p_time;   // 窓口がふさがった時刻
			if (ent[k2].s_t == 0)   // 窓口のサービス終了時刻
				ent[k2].end_time = base.p_time + Exp_b(ent[k2].mean);
			else
				ent[k2].end_time = base.p_time + ent[k2].mean;
		}
	}
/*
          窓口使用時間の処理
*/
	ent[kk].service  = 0;   // 窓口を空き状態にする
	ent[kk].c_busy  += (base.p_time - ent[kk].busy_t);   // 窓口がふさがっている時間の累計
/*
          この窓口に対する待ち行列がある場合
*/
	let k3 = ent[kk].in_n;
	if (que[k3].que.length > 0) {
		que[k3].c_ql += que[k3].que.length * (base.p_time - que[k3].ql_t);   // 待ち行列長にその長さが継続した時間を乗じた値の累計
		let n = que[k3].que.shift();   // 待ち行列の先頭にいる客の削除
		que[k3].ql_t =  base.p_time;   // 現在の待ち行列長になった時刻
		let m  = base.Search(n);
		x1 = base.p_time - cus[m].time;
		que[k3].c_wt += x1;   // 待ち時間の累計
		if (x1 > que[k3].max_wt)
			que[k3].max_wt = x1;   // 最大待ち時間
		for (let i1 = 0; i1 < que[k3].m; i1++) {
			let k4 = que[k3].out_n[i1];   // 窓口
			if (ent[k4].service == 0) {
				ent[k4].service = n;   // 窓口の客番号
				ent[k4].busy_t  = base.p_time;   // 窓口がふさがった時刻
				if (ent[k4].s_t == 0)   // 窓口のサービス終了時刻
					ent[k4].end_time = base.p_time + Exp_b(ent[k4].mean);
				else
					ent[k4].end_time = base.p_time + ent[k4].mean;
				cus[m].state1 = 1;   // 客の状態変更(サービス中)
				cus[m].state2 = k4;   // 客の状態変更(窓口番号)
				break;
			}
		}
	}
}

/****************************/
/* 指定した客の配列上の位置 */
/*      nm : 客番号         */
/*      return : 要素番号   */
/****************************/
Q_base.prototype.Search = function(nm)
{
	let n = -1;

	for (let i1 = 0; i1 < cus.length; i1++) {
		if (cus[i1].num == nm) {
			n = i1;
			break;
		}
	}

	return n;
}

/**************************/
/* 統計量の計算と最終出力 */
/**************************/
Q_base.prototype.Output = function()
{
					// System
	let str = "全客数 " + base.nc;
	str += " 最大系内客数 " + base.max_c + " 最大滞在時間 " + Math.round(1000*base.max_sys)/1000 + "\n";
	str += "平均系内客数 " + Math.round(1000*base.c_now_c/base.p_time)/1000;
	str += " 平均滞在時間 " + Math.round(1000*base.c_sys/base.nc)/1000;
	str += " 終了時間 " + Math.round(1000*base.p_time)/1000 + "\n";
					// Entity
	for (let i1 = 0; i1 < ent.length; i1++) {
		let e = ent[i1];
		str += "Entity " + e.name;
		str += " 稼働率 " + Math.round(1000*e.c_busy/base.p_time)/1000 + "\n";
	}
					// Queue
	for (let i1 = 0; i1 < que.length; i1++) {
		let q = que[i1];
		str += "Queue " + q.name;
		str += " 客数 " + q.nc;
		str += "   最大待ち行列長 " + q.max_q_l;
		str += "   最大待ち時間 " + Math.round(1000*q.max_wt)/1000 + "\n";
		str += "      平均待ち行列長 " + Math.round(1000*q.c_ql/base.p_time)/1000;
		str += "   平均待ち時間 " + Math.round(1000*q.c_wt/q.nc)/1000 + "\n";
	}

	document.getElementById("res").value = str;
}
